using SDL;
using SDLGraphics;
using SDLImage;

namespace invadersGame{
  
  class GameObject : Object{
    
    protected SDL.Rect my_rect;
    
    protected float speed;
    protected float pos_x;
    protected float pos_y;
    protected uint32 last_frame;
    
    public struct MovmentVector {
      /** MovmentVector
       * Is used for storting a movement vector.
       * IE: if it should move up (y < 0), up (y > 0), left (x < 0),
       * right (x > 0).
       */
      int delta_x; /* The delta of the object can have thee states:
                    delta_x < 0,  delta_x = 0  or delta_x > 0*/
      int delta_y; /* See above */
      int speed; /* Maximum movement over Time (in seconds) */
    } //MovmentVector
    
    int health; /* HP */
    
    MovmentVector mMovmentVector;
    
    public GameObject(int16 x, int16 y, int delta_x, int delta_y,
                      int speed, int health){
      
      my_rect = SDL.Rect ();
      my_rect.x = x;
      my_rect.y = y;
      pos_x = x;
      pos_y = y;
      
      this.speed = speed;
      last_frame = SDL.Timer.get_ticks();
    }
    
    public virtual void draw(SDL.Screen screen) {
      ResourceHandler.image_null.blit(null ,screen,my_rect);
    }
    
    public virtual void move() {
      // Do nothing!
    }
  }
}





